10 REM FLIGHT SIMULATION
11 REM COPYRIGHT ESTES INDUSTRIES, 1990.
15 PRINT
20 PRINT "FLIGHT SIMULATION PROGRAM"
22 PRINT "BY MICHAEL L. GASPERI"
25 PRINT
27 PRINT "COPYRIGHT ESTES INDUSTRIES, 1990. ALL RIGHTS RESERVED."
30 PRINT
100 REM DIMENSION ARRAY AND INITIALIZE VARIABLES
110 DIM F(25)
120 F(0) = 0
130 G = 9.8
140 RH = 1.23
150 AF = 0
160 FM = 1
170 TS$ = "TIME SEC       ACCEL M/S2    VELOC M/S       ALT M"
180 TE$ = "TIME SEC       ACCEL FT/S2   VELOC FT/S      ALT FT"
190 REM ENGINE DATA BASE
200 REM  "TYPE" , PM ,DM ,CM ,JM,DT ,F1 ,F2 ,...,0.0
210 DATA "1/4A3",0.88,.20,3.0,.4,.05,2.8,6.0,2.8,0.0
220 DATA "1/2A3",1.75,.20,3.0,.4,.05,2.8,6.0,7.6,3.3,2.8,2.5,0.2,0.0
230 DATA "1/2A6",1.56,.46,11.,.5,.05,5.0,9.0,5.0,0.0
240 DATA "A3"   ,3.50,.20,3.0,.4,.05,3.0,6.0,8.0,3.0,2.8,-11,2.5,0.0
250 DATA "A8"   ,3.12,.46,11.,.5,.05,2.0,5.0,11.,13.,9.0,0.0
260 DATA "A10"  ,3.78,.20,3.0,.4,.05,6.0,13.,12.,7.0,1.0,0.0
270 DATA "B4"   ,8.33,.46,11.,.5,.10,4.0,13.,5.0, -8,3.5,0.2,0.0
280 DATA "B6"   ,6.24,.46,11.,.5,.10,4.5,12.,8.5,5.8, -3,5.5,2.5,0.0
290 DATA "B8"   ,6.24,.46,11.,.5,.10,2.0,10.,23.,10.,6.0,1.0,0.0
300 DATA "C5"   ,12.7,.46,11.,.5,.10,2.0,10.,23.,10.,6.0,-15,3.5,0.0
310 DATA "C6"   ,12.5,.46,11.,.5,.10,4.5,12.,8.8,6.0,5.8,-11,5.7,0.0
320 DATA "D11"  ,18.5,.45,16.,.5,.10,7.0,22.,28.,21.,11., -7,9.5,0.0
330 DATA "D12"  ,24.9,.45,16.,.5,.10,7.0,22.,28.,21.,11.,-12,9.5,0.0
340 DATA "LAST"
350 REM DISPLAY KNOWN ENGINE TYPES
360 PRINT "ENGINE TYPES:"
370 READ N$
380 IF N$ = "LAST" THEN 420
390 PRINT N$;" ";
400 READ J : IF J <> 0 THEN 400
410 GOTO 370
420 PRINT
430 RESTORE
440 REM PROMPT FOR SELECTED ENGINE
450 PRINT "ENGINE TYPE (USE CAPITAL LETTERS): "
460 INPUT NQ$
470 PRINT "TIME DELAY (SECONDS): "
480 INPUT TD
490 PRINT "LOADING ENGINE DATA ";
500 READ N$
510 PRINT ".";
520 IF N$ = "LAST" THEN PRINT " UNKNOWN TYPE ENTERED" : GOTO 420
530 REM READ MASS DATA AND TIME STEP
540 READ PM,DM,CM,JM,DT
550 IT = 0
560 I = 1
570 REM READ THRUST DATA
580 READ F(I)
590 REM NORMAL POINT
600 IF F(I) > 0 THEN IT = IT+F(I)*DT : I = I+1 : GOTO 580
610 REM LAST POINT
620 IF F(I) = 0 THEN 710
630 REM SUSTAIN SECTION POINTS INDICATED BY - THRUST
640 FR = -F(I)
650 READ F(I)
660 REM EXPAND DATA FOR SUSTAIN
670 FOR J = I TO I+FR-1 : F(J) = F(I) : IT = IT+F(I)*DT : NEXT J
680 I = I+FR
690 GOTO 580
700 REM CHECK IF THIS ENGINE IS THE ONE SELECTED
710 IF N$ <> NQ$ THEN 500
720 REM CALCULATE BURN, COAST AND TOTAL TIME
730 BT = I
740 CT = TD/DT
750 ET = BT+CT
760 REM CALCULATE TOTAL ENGINE MASS
770 EM = PM+DM*TD+CM+JM
780 REM PROMPT FOR LAUNCH DATA
790 PRINT
800 PRINT "ROCKET WEIGHT W/O ENGINE (OUNCES): "
810 INPUT RW
820 RM = RW*.02835
830 PRINT "ROCKET MAX DIAMETER (INCHES): "
840 INPUT RD
850 RD = RD*.0254
860 PRINT "DRAG COEFFICIENT (TYPICAL .75): "
870 INPUT CD
880 PRINT "LAUNCH TEMPERATURE (F): "
890 INPUT T
900 REM CALCULATE DRAG PARAMETER
910 K = 3.14159*CD*(RD/2)*(RD/2)/2*RH*(1.11-T*.0018)
920 PRINT "OUTPUT IN METRIC OR ENGLISH UNITS (M OR E): "
930 INPUT U$
940 IF U$ = "E" THEN TS$ = TE$ : FM = 3.281
950 M = RM+EM/1000
960 REM START OF SIMULATION LOOP
970 PRINT
980 PRINT "IGNITION"
990 PRINT TS$
1000 FOR I = 0 TO ET
1010 REM CALCULATE MASS AND ACCELERATION
1020 IF I <= BT THEN M = M-PM*(F(I)*DT/IT)/1000 : A = F(I)/M-K/M*V*V-G
1030 IF I > BT THEN M = M-DM*DT/1000 : A = -SGN(V)*K/M*V*V-G
1040 REM CALCULATE DIFFERENCE EQUATIONS
1050 V = V+A*DT
1060 Z = Z+V*DT
1070 REM CHECK CURRENT STATE OF VARIABLES
1080 IF I = BT THEN PRINT "BURNOUT" : PRINT TS$
1090 IF Z < 0 AND AF = 1 THEN PRINT "CRASH" : GOTO 1160
1100 IF Z < 0 THEN A = 0 : V = 0 : Z = 0
1110 IF V < 0 AND AF = 0 THEN PRINT "APOGEE" : AF = 1 : PRINT TS$
1120 REM PRINT STEP VALUES
1130 PRINT I*DT,A*FM,V*FM,Z*FM
1140 NEXT I
1150 PRINT "EJECTION"
1160 END
