10 REM MODEL ROCKET PERFORMANCE PREDICTION
15 REM COPYRIGHT ESTES INDUSTRIES, 1990
17 PRINT
25 PRINT "PERFORMANCE PREDICTION"
27 PRINT "BY MICHAEL L. GASPERI"
28 PRINT
35 PRINT "COPYRIGHT ESTES INDUSTRIES 1990.  ALL RIGHTS RESERVED."
40 PRINT
100 REM DEFINE HYPERBOLIC SINE FUNCTION
110 DEF FNS(X)=(EXP(X)-EXP(-X))/2
120 REM DEFINE HYPERBOLIC COSINE FUNCTION
130 DEF FNC(X)=(EXP(X)+EXP(-X))/2
140 REM DEFINE HYPERBOLIC TANGENT FUNCTION
150 DEF FNT(X)=FNS(X)/FNC(X)
160 PRINT
170 PRINT "ENTER ENGINE TOTAL IMPULSE (LB-S)"
180 INPUT E
190 PRINT "ENTER ENGINE THRUST DURATION (S)"
200 INPUT L
210 REM CALCULATE AVERAGE THRUST IN OUNCES
220 T=16*E/L
230 PRINT "ENTER ENGINE INITAL WEIGHT (OZ)"
240 INPUT I
250 PRINT "ENTER ENGINE PROPELLANT WEIGHT (OZ)"
260 INPUT P
270 PRINT "ENTER ROCKET WEIGHT W/O ENGINE (OZ)"
280 INPUT R
290 PRINT "ENTER ROCKET DIAMETER (IN)"
300 INPUT D
310 PRINT "ENTER ROCKET DRAG COEF. (.75 IS TYPICAL)"
320 INPUT C
330 REM CALCULATE AVERAGE WEIGHT DURING THRUSTING
340 W=R+I-P/2
350 REM CALCULATE CROSS SECTIONAL AREA OF ROCKET
360 M=3.14159*(D/2)*(D/2)
370 REM CALCULATE BALISTIC COEF DURING THRUSTING
380 B=W/C/M
390 REM CALCULATE DRAG FREE ACCELERATION
400 A=T/W-1
410 REM CALCULATE BURNOUT ALTITUDE (LOG=NATURAL LOG)
420 S=235.26*B*LOG(FNC(.36981*SQR(A)*L/SQR(B)))
430 PRINT
440 PRINT "BURNOUT ALTITUDE = ";S;" FT"
450 REM CALCULATE BURNOUT VELOCITY
460 V=87*SQR(B)*SQR(A)*FNT(.36981*SQR(A)*L/SQR(B))
470 PRINT "BURNOUT VELOCITY = ";V;" FT/S"
480 REM CALCULATE AVERAGE WEIGHT DURING COASTING
490 W=R+I-P
500 REM CALCULATE BALISTIC COEF DURING COASTING
510 B=W/C/M
520 REM CALCULATE COASTING DISTANCE
530 Z=117.63*B*LOG(1+V*V/B/7569.386)
540 PRINT "COASTING DISTANCE = ";Z;" FT"
550 REM CALCULATE TOTAL ALTITUDE
560 H=S+Z
570 PRINT "TOTAL ALTITUDE = ";H;" FT"
580 REM CALCULATE COASTING TIME (ATN = RADIAN ARC TANGENT)
590 K=2.7041*SQR(B)*ATN(V/87/SQR(B))
600 PRINT "COASTING TIME = ";K;" S"
610 PRINT
620 END
